Bug 586766

Summary: udev loads framebuffer driver in text mode (level 3) - black screen after udev stars
Product: [Fedora] Fedora Reporter: Anton Guda <atu>
Component: udevAssignee: udev-maint
Status: CLOSED WONTFIX QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: medium Docs Contact:
Priority: low    
Version: 14CC: harald, jonathan
Target Milestone: ---   
Target Release: ---   
Hardware: All   
OS: Linux   
Fixed In Version: Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2012-08-16 18:22:35 EDT Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Description Anton Guda 2010-04-28 06:43:11 EDT
Description of problem:
For some tasks I prefer to use text mode,
so my default initlevel is 3, plymouth is disabled,
X starts only on demand (by startx).
Bare textmode required.
After switching to KMS (required by intel and nouveau), 
kernel loads, init starts, udev loads framebuffer
driver - screen is black (powersaving mode).
After blind login, video my be restored
or by modprobe fbcon (horrible small chars, ...),
or by startx.

For radeon it was a workaround: nomodeset in kernel cmdline.
For nvidia cards - fallback to nv driver.
But its no workaround for intel graphics -
it refuse to work w/o KMS.

Version-Release number of selected component (if applicable):

it seems that some previous versions too.
I detected this only when use motherboard with Intel
graphics onboard.

How reproducible:

Steps to Reproduce:
1. disable plymouth.
2. initdefault=3
3. remove nomodeset if exist
4. boot
Actual results:
udev loads framebuffer driver - black screen.

Expected results:
Bare text mode.
Loading fbcon is not a solution - 
danger in case of framebuffer errors,
bare textmode can provide better view,
dont require manual font loading after manual
fbcon load.

It may be better to provide a switch in udev config
- load/skip framebuffer+fbcon drivers.

Additional info:
Comment 1 Harald Hoyer 2010-04-28 07:02:18 EDT
why don't you blacklist the framebuffer driver?

# echo blacklist <driver> > /etc/modprobe.d/myblacklist.conf
Comment 2 Harald Hoyer 2010-04-28 07:04:12 EDT
most framebuffer drivers are blacklisted by default anyway...

$ grep -r blacklist /etc/modprobe.d/
/etc/modprobe.d/blacklist.conf:blacklist aty128fb
/etc/modprobe.d/blacklist.conf:blacklist atyfb
/etc/modprobe.d/blacklist.conf:blacklist radeonfb
/etc/modprobe.d/blacklist.conf:blacklist i810fb
/etc/modprobe.d/blacklist.conf:blacklist cirrusfb
/etc/modprobe.d/blacklist.conf:blacklist intelfb
/etc/modprobe.d/blacklist.conf:blacklist kyrofb
/etc/modprobe.d/blacklist.conf:blacklist i2c-matroxfb
/etc/modprobe.d/blacklist.conf:blacklist hgafb
/etc/modprobe.d/blacklist.conf:blacklist nvidiafb
/etc/modprobe.d/blacklist.conf:blacklist rivafb
/etc/modprobe.d/blacklist.conf:blacklist savagefb
/etc/modprobe.d/blacklist.conf:blacklist sstfb
/etc/modprobe.d/blacklist.conf:blacklist neofb
/etc/modprobe.d/blacklist.conf:blacklist tridentfb
/etc/modprobe.d/blacklist.conf:blacklist tdfxfb
/etc/modprobe.d/blacklist.conf:blacklist virgefb
/etc/modprobe.d/blacklist.conf:blacklist vga16fb
/etc/modprobe.d/blacklist.conf:blacklist viafb

so you might want the blacklist.conf file to be extended with your driver..

$ rpm -qf /etc/modprobe.d/blacklist.conf
Comment 3 Anton Guda 2010-04-28 10:12:30 EDT
Really, all are blacklisted and loaded by udev.
I can disable loading by blacklist 'fb'.
The same result can be achieved by 'nomodeset'
(even better, in this case radeon works).
But after such disabling X failed to start on
intel, nouveau.

The bug is not in loadding framebuffer,
but in loading not in time.
But what to do after X exits - framebuffer
will not unloaded.

I will try to configure fbcon to mimic real
text mode, with in-time loading, 
font loading and so on.
Comment 4 Harald Hoyer 2010-06-25 07:29:24 EDT
(In reply to comment #3)
> Really, all are blacklisted and loaded by udev.

?? blacklisted modules should not be loaded by udev.
Comment 5 Anton Guda 2010-06-25 13:49:07 EDT
It seems to udev-only or Fedora only bug.
In most of modern distributives it's 
impossible to have both text and graph mode in
one boot (except radeon). If nomodeset is given
in kernel options, text mode works perfectly,
but X fail to start on intel, nouveau.
If nomodeset is not given in kernel cmdline,
X works, but during boot framebuffer inits
(as far as I researched, in udev phase, but I fail to find
udev rule, which result to this phenomena).

I suppose to use nomodeset on servers.
In workstations with nvidia and intel it seems to
unavoidable to use framebuffer. But I fail to found,
how to control fb. For example, udev dont inits fonts
on fb console, and have no way to control relolution.
If I try to load fbcon manualy _before_ udev,
all keymaps and font loaded, but a very long (2-3min)
delay occured before mode changed (but udev switches modes fast).
Comment 6 Bug Zapper 2010-07-30 07:29:46 EDT
This bug appears to have been reported against 'rawhide' during the Fedora 14 development cycle.
Changing version to '14'.

More information and reason for this action is here:
Comment 7 Fedora Admin XMLRPC Client 2011-10-20 12:10:55 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 8 Fedora Admin XMLRPC Client 2011-10-20 12:12:22 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 9 Fedora Admin XMLRPC Client 2011-10-20 12:15:16 EDT
This package has changed ownership in the Fedora Package Database.  Reassigning to the new owner of this component.
Comment 10 Fedora End Of Life 2012-08-16 18:22:38 EDT
This message is a notice that Fedora 14 is now at end of life. Fedora 
has stopped maintaining and issuing updates for Fedora 14. It is 
Fedora's policy to close all bug reports from releases that are no 
longer maintained.  At this time, all open bugs with a Fedora 'version'
of '14' have been closed as WONTFIX.

(Please note: Our normal process is to give advanced warning of this 
occurring, but we forgot to do that. A thousand apologies.)

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, feel free to reopen 
this bug and simply change the 'version' to a later Fedora version.

Bug Reporter: Thank you for reporting this issue and we are sorry that 
we were unable to fix it before Fedora 14 reached end of life. If you 
would still like to see this bug fixed and are able to reproduce it 
against a later version of Fedora, you are encouraged to click on 
"Clone This Bug" (top right of this page) and open it against that 
version of Fedora.

Although we aim to fix as many bugs as possible during every release's 
lifetime, sometimes those efforts are overtaken by events.  Often a 
more recent Fedora release includes newer upstream software that fixes 
bugs or makes them obsolete.

The process we are following is described here: